<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: webcategories.php,v 1.12 2010-02-12 21:13:11 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');


/**
 * global.list.limit
 * com_linkdirectory2.limitstart
 * limit
 * limitstart
 * com_linkdirectory2.catgegory_tree
 */
class LinkDirectory2ModelWebcategories extends JModel {
	private $_data = null;
	private $_total = null;
	private $_pagination = null;

	/**
	 */
	public function __construct() {
		parent::__construct();
		global $option;
		$mainframe = JFactory::getApplication();
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		if ($mainframe->getUserState( $option.'.catgegoriesAsTree') === null){
			$mainframe->setUserState( $option.'.catgegoriesAsTree',true);
		}
	}

	/**
	 * Speichert im UserState, ob die Daten in Form eines Baumes oder flach 
	 * abgebildet werden sollen. 
	 * @param boolean $treeModel true für Baum-Abbildung, false für flache Abbildung
	 * 
	 */
	public function setTreeModel($treeModel=true){
		global $option;
		$mainframe = JFactory::getApplication();
		$mainframe->setUserState( $option.'.catgegoriesAsTree',$treeModel);
	}
	
	/**
	 * Liefert true, wenn die Daten als Baum abgebildet werden soll und false, wenn 
	 * die Daten flach abgebildet werden sollen.
	 * 
	 *  @return true, wenn Daten als Baum abgebildet werden sollen, sonst false.
	 *
	 */
	public function getTreeModel(){
		global $option;
		$mainframe = JFactory::getApplication();
		return $mainframe->getUserState( $option.'.catgegoriesAsTree',true);
	}
	
	/**
	 */
	public function &getData(){
		global $option;
		$mainframe = JFactory::getApplication();
		if (empty($this->_data)){
			$limit 		= $this->getState('limit');
			$limitstart = $this->getState('limitstart');
			$levellimit = 20;

			$query = $this->_buildQuery();
			$this->_db->setQuery( $query );
			$rows = $this->_db->loadObjectList();
			if ($this->getTreeModel()) {
				$children = $this->_getTreeFromList($rows);
				jimport('joomla.html.html');
				$filter_catid		= $mainframe->getUserStateFromRequest( $option.'filter_catid',		'filter_catid',		0,				'int' );
				$list = JHTML::_('menu.treerecurse', $filter_catid, '', array(), $children, max(0, $levellimit-1));
			} else {
				foreach ($rows as $row){
					$row->treename = $row->name;
				}
				$list = $rows;
			}
			$this->_total = count($list);
			if (($limitstart == 0 ) && ($limit == 0)) {
				$this->_data = array_slice($list,$limitstart,$this->getTotal());
			} else { 
				$this->_data = array_slice($list,$limitstart,$limit);
			}
		}
		return $this->_data;
	}

	/**
	 */
	private function _buildQuery() {
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();
		$query = 'SELECT  c.*, c.parent_id as parent, g.name AS groupname, u.name AS editor,'
			. ' COUNT( l3.catid ) AS totalLinks '
			. ' FROM #__ldcats AS c'
			. ' LEFT JOIN #__users AS u ON u.id = c.checked_out '
			. ' LEFT JOIN #__groups AS g ON g.id = c.access '
			. ' LEFT JOIN #__ldlinks AS l3 ON l3.catid = c.id '
			. $where
			. ' GROUP BY c.id '
			. $orderby
		;
		return $query;
	}
	
	/**
	 */
	private function _buildContentOrderBy() {
		global $option;
		$mainframe = JFactory::getApplication();
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'c.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		if ($filter_order == 'c.ordering' || $filter_order == ''){
			$orderby 	= ' ORDER BY c.ordering, c.name '.$filter_order_Dir ;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , c.ordering ';
		}
		return $orderby;
	}
	
	/**
	 */
	private function _buildContentWhere() {
		global $option;
		$mainframe = JFactory::getApplication();
		$where = array();
		if ($this->getTreeModel()){
			$search = '';
			$filter_state = '';
		} else {
			$search				= $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
			$search				= JString::strtolower( $search );
			$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state','filter_state','','word' );
		}
		if ($search) {
			$where[] = 'LOWER(c.title) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'c.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'c.published = 0';
			}
		}
		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		return $where;
	}
	
	/**
	 */
	private function &_getTreeFromList(&$rows){
		if (count($rows)==1){
			$children = array();
			$list = array();
			array_push($list, $rows[0]);
			$children[0] = $list;
		} else {
			$children = array();
			$found = false;
			foreach ($rows as $v) {
				$pt = $v->parent;
				$list = @$children[$pt] ? $children[$pt] : array();
				array_push($list, $v);
				$children[$pt] = $list;
			}
		}
		return $children;
	}

	/**
	 */
	public function getTotal() {
		if (empty($this->_total)){
			$this->_total=count($this->getData());
		}
		return $this->_total;
	}

	/**
	 */
	public function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$total = $this->getTotal();
			$limitstart = $this->getState('limitstart');
			$limit = $this->getState('limit');
			if ($limitstart > $total) {
				$limitstart = (int)(ceil($total / $limit) - 1) * $limit;
			}
			$this->_pagination = new JPagination( $total, $limitstart , $limit );
		}
		return $this->_pagination;
	}
}
?>