<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: SearchUtils.php,v 1.6 2010-02-14 22:02:45 neschkeh Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';

class SearchUtils {

	public  static function  getSearchTypeDefault(){
		$confUtils = new ConfUtils();
		if ($confUtils->isLinkSearchEnable()) {
			return 'links';
		} elseif ($confUtils->isCategorySearchEnable()) {
			return 'categories';
		}
		return '';
	}

	private function getCheckedField($searchtype){
		$checked= array();
		switch ($searchtype){
			case 'categories':
				$checked['categories']='checked="checked"';
				$checked['links']='';
				break;
			case 'links':
				$checked['links']='checked="checked"';
				$checked['categories']='';
				break;
			default:
				$checked['links']='checked="checked"';
				$checked['categories']='';
		}
		return $checked;
	}

	public static function &getSearchModel($searchtype){
		switch ($searchtype){
			case 'categories':
				return JModel::getInstance('categories', 'LinkDirectory2Model');
			case 'links':
				return JModel::getInstance('links', 'LinkDirectory2Model');
		}
		return NULL;
	}

	public static function getSearchType(){
		$searchtypeDefault=self::getSearchTypeDefault();
		$searchtype = JRequest::getString('searchtype',$searchtypeDefault);
		switch ( $searchtype){
			case 'categories':
			case 'links':
				return $searchtype;
		}
		return $searchtypeDefault;
	}

	public  static function getSearchResultTemplate($searchtype){
		switch ( $searchtype){
			case 'categories':
				return 'categorieslist';

			case 'links':
				return 'links';
		}
	}

	public static function setSearchParameterIntoView(&$view){
		$searchtypeDefault=self::getSearchTypeDefault();
		$searchtype = JRequest::getString('searchtype',$searchtypeDefault);
		$confUtils = new ConfUtils();
		if ($confUtils->isLinkSearchEnable() && $confUtils->isCategorySearchEnable()){
			$type="radio";
			$linkSearchLabel=JText::_('LD_SEARCH_LINKS');
			$catSearchLabel=JText::_('LD_SEARCH_CATEGORIES');
		} else {
			$type="hidden";
			$linkSearchLabel='';
			$catSearchLabel='';
		}
		$searchtext = JRequest::getString('searchtext','');
		$view->assign('searchEnable',$confUtils->isSearchEnable());
		$view->assign('linkSearchEnable',$confUtils->isLinkSearchEnable());
		$view->assign('categorySearchEnable',$confUtils->isCategorySearchEnable());
		$checked=self::getCheckedField($searchtype);
		$view->assign('lchecked',$checked['links']);
		$view->assign('cchecked',$checked['categories']);
		$view->assign('searchtype',$searchtype);
		$view->assign('searchtext',$searchtext);
		$view->assign('type',$type);
		$view->assign('linkSearchLabel',$linkSearchLabel);
		$view->assign('catSearchLabel',$catSearchLabel);
	}
	
	
	/**
	 * Where-Klausel, um aktuelle und alle deren Unterkategorien zu ermitteln.
	 *
	 * @param int $catid Katehorie-Id
	 * @param $columnName Spaltenname der KategoieId in der Tabelle #__ldlinks bzw. #__ldcats
	 * @param Array mit $where-Klausel, deren Elemente später mit AND verknüpft werden
	 * @global ld->searchonlyinsubcats
	 */
	static public function getWhereAllSubCategoriesFor($catid,$columnName,&$where){
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php');
		$ld = new LDConfig();
		if ( ( $catid > 0 ) && $ld->searchonlyinsubcats) {
			$whereSubCat[] = $catid;
			self::getAllSubCategoriesFromCategorie($catid, $whereSubCat);
			if (count ($whereSubCat) == 1){
				$where[] = $columnName . ' = '. $whereSubCat[0];
			} elseif (count ($whereSubCat) > 1){
				$where[] = $columnName . ' in (' . implode( ' , ', $whereSubCat ) .')';
			}
		}
	}
	
	static private function getAllSubCategoriesFromCategorie($catid,&$whereSubCat) {
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		// TODO access wieder auswerten
		$query = "SELECT id FROM #__ldcats "
		. " WHERE parent_id = $catid "
		. " AND published = 1 "
		//. " AND access <= $user->gid"
		;
		$db->setQuery($query);
		$subcats = $db->loadObjectList();
		if (count($subcats)) {
			foreach ($subcats as $subcat) {
				$whereSubCat[] = (int)$subcat->id;
				self::getAllSubCategoriesFromCategorie($subcat->id, $whereSubCat);
			}
		}
	}
	
}
?>